#ifndef _ALLARCH_H
#define _ALLARCH_H

/*
	Constants shared by all architectures
*/

/*
 * Naming convention _P at the end of constant name means,
 * that this constant is in "pointers". 
 * When used, should be multiplied by POINTER_SIZE of concrete architecture
 */


#define GB_1 1099511627776LLU	// 1 GB
#define MB_4 4194304		// 4 MB
#define MB_2 2097152		// 2 MB
#define MB_1 1048576		// 1 MB
#define KB_64 65536		// 64 KB
#define KB_16 16384		// 16 KB
#define KB_4 4096		// 4 KB
#define KB_1 1024		// 1 KB

// Increase, if need support for more architectures;)
#define MAX_ARCHITECTURES 10

// Increase, if need support for more operating systems;)
#define MAX_OS 10


//XXX WILL BE REMOVED
//definitions of operating systems
#define OS_UNKNOWN	0
#define OS_LINUX	1
#define OS_WINDOWS	2
// any OS "bellow" 10, important is list_head type
#define OS_CIRC_HL	10	
#define OS_BSD		11


// constants for patterns
#define P_HEX	0	// some value
#define P_UNK	1	// unknown value
#define P_NZ	2	// non-zero

// MAGIC section...
// Linux specials


// This part is going to be REMOVED too:
// Settings are now OS-specific

// ----- task_struct -----

#define TS_MAGIC_FILES_MAX_TRIES 100
// how many times try to find "files" inside task_struct (20 should be enough;)

#define TS_MAGIC_HEADLIST_MAX 20
// Max. how many headlists we expect before comm in task_struct. 

#define TS_COMM_LEN 16
//length of comm array of chars (process name)


// ----- mm_struct -----

// ----- module -----
#define MODULE_MAGIC_OPT_ADDR 0x30000000
// optimization when looking for module. 
// usually, modules are beyond 0x3000000, so we can save reading of 1G of data
// If this fail, we perform full scan
// architecture depentent (!)


#define MD_MAGIC_HEADLIST_MAX 10
// Max. how many headlists we expect before name in module

#define MD_NAME_LEN 64
// length of comm array of chars (module name)


// file things are not used now...

// ----- qstr struct -----
#define QS_MAGIC_MAX_FILENAME_SIZE 512
// max. how long can be filename, when trying to list open files

// ----- dentry struct -----
#define DT_MAGIC_MAX_TRIES 20
// max. how many times try to verify qstr inside dentry struct

// ----- vfs struct -----
#define VFS_MAGIC_MAX_TRIES 20	// max. how many try to verify devname inside vfs_struct
#define VFS_MAGIC_PATTERN  "/dev/"	// pattern we are looking for when verifying vfs_struct
#define VFS_MAGIC_PATTERN_LEN 5 // length of pattern when verifying vfs_struct

// ----- files_struct -----
#define FS_MAGIC_MAX_TRIES 20  //max. how many times try to find fdt inside files_struct

// ----- fdtable struct -----
#define FD_MAGIC_MAX_TRIES 20  //max. how many times try to find fd inside fdtable_struct

// ----- file struct -----
#define FL_MAGIC_MAX_TRIES 20  //max. how many times try to find fdt inside file_struct 

// Maximal number of processes that can found in analysed system
#define MAX_PROC_FOUND	65535

// Maximal size of analysed list
#define MAX_LIST_SIZE	65535

#endif
